void(*resetFunc)(void) = 0; //reset function @ address 0

//#include <EthernetENC.h>
#include <SPI.h>
//#include <UIPEthernet.h>
#include <Ethernet.h>
// Beep 1 - Transmit Failed
// Beep 2 - Start modem
// Beep 4 - Transmit success
// Beep 5 - Low Batteries
// A0 to A3, Counter disabled to 0
// set value
String LogerID = "PO-WTPMKARSA;TNLG011"; //7 char only 
int Bat12 = 260; // analogRead(5) for battery 12.0 volts
int mKirim = 10; // jangka kirim (menit) genap ganjil dgn sample
int mSample = 3; // jangka sampling (menit)
unsigned long maxcomretry = 4; // max minutes to connect internet

//runtime variable
char serverName[] = "scadatirtanadi.mooo.com";
unsigned long DCount[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
boolean DLast[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
unsigned long secTimeBase = 0;
unsigned long lastime = 0;
unsigned long lasTM = 0;
unsigned long comstartime = 0;
unsigned long AnRead = 0;
String sCom, sC1, sC2, sC3, sC4, sC5, sC6, sC7, sC8, sC9, sC10 ;
String sC11, sC12, sC13, sC14, sC15, sC16, sC17, sC18, sC19, sC20 ;
String sC21, sC22, sC23, sC24, sC25, sC26, sC27, sC28, sC29, sC30 ;
int constatus = 0;
int comretry = 0;
int uBaca = 0;
int sComLong = 0;
int SendFail = 0;

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};



//IPAddress ip(192, 168, 1, 211);
// Enter the IP address of the server you're connecting to:
IPAddress server(202, 152, 39, 218);

// Initialize the Ethernet client library
// with the IP address and port of the server
EthernetClient client;



void setup() {
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("\r\nSTARTING");
  sComRead();
}


void loop () {
  // sending sample
  if (((millis() / 60000) % mKirim == 0) && (sC1.startsWith("A0-") == 1))  {
    ComSend();
  }
  // read sample
  if (((millis() / 60000) % mSample == 0) && ((millis() / 60000) != lasTM)) {
    Serial.println("Sampling " + String(mKirim - (millis() / 60000) % mKirim));
    sComRead();
    lasTM = millis() / 60000 ;
  }
  mydelay(10);
}

void ComSend() {
  Serial.println("Sending");
  Beep(2);
  comstartime = millis();
  comretry = 0;
  SetModemON();
  // if you get a connection, report back via serial:
  constatus = client.connect(serverName, 6013);
  while ((constatus != 1) && (millis() < (comstartime + (maxcomretry*60*1000)))) {
    Serial.println("fail, retry " + String(comretry));
    comretry = comretry + 1;
    mydelay(1);
    constatus = client.connect(serverName, 6013);
    if (millis() >= (comstartime + (maxcomretry*60*1000))) {
      Serial.println("Skip");
      SendFail = SendFail + 1;
    }
  }
  if (client.connected()) {
    Serial.println("connected");
    Serial.println(sC30 + sC29 + sC28 + sC27 + sC26 + sC25 + sC24 + sC23 + sC22 + sC21 + sC20 + sC19 + sC18 + sC17 + sC16 + sC15 + sC14 + sC13 + sC12 + sC11 + sC10 + sC9 + sC8 + sC7 + sC6 + sC5 + sC4 + sC3 + sC2 + sCom + "MR-" + String((millis() - comstartime) / 1000) + ";" + LogerID);
    client.print(sC30 + sC29 + sC28 + sC27 + sC26 + sC25 + sC24 + sC23 + sC22 + sC21 + sC20 + sC19 + sC18 + sC17 + sC16 + sC15 + sC14 + sC13 + sC12 + sC11 + sC10 + sC9 + sC8 + sC7 + sC6 + sC5 + sC4 + sC3 + sC2 + sCom + "MR-" + String((millis() - comstartime) / 1000) + ";" + LogerID);
    client.stop();
    Serial.println("send " + String(millis() - comstartime) + " mS");
    comretry = 0;
    // matikan modem
    SetModem(LOW);
    ClrsCom();
    Beep(3);
    SendFail = 0;
    if ((millis() / 60000) > 9000) {
      resetFunc();
    }
  }
  // matikan modem
  SetModem(LOW);
  Beep(1);
  if (SendFail >= (360/mKirim)) {
      resetFunc();
  }
}

void SavesCom() {
  // shift save
  sC30 = sC29; sC29 = sC28; sC28 = sC27; sC27 = sC26; sC26 = sC25;
  sC25 = sC24; sC24 = sC23; sC23 = sC22; sC22 = sC21; sC21 = sC20;
  sC20 = sC19; sC19 = sC18; sC18 = sC17; sC17 = sC16; sC16 = sC15;
  sC15 = sC14; sC14 = sC13; sC13 = sC12; sC12 = sC11; sC11 = sC10;
  sC10 = sC9; sC9 = sC8; sC8 = sC7; sC7 = sC6; sC6 = sC5;
  sC5 = sC4; sC4 = sC3; sC3 = sC2; sC2 = sC1; sC1 = sCom;
}

void ClrsCom() {
  sC30 = ""; sC29 = ""; sC28 = ""; sC27 = ""; sC26 = "";
  sC25 = ""; sC24 = ""; sC23 = ""; sC22 = ""; sC21 = "";
  sC20 = ""; sC19 = ""; sC18 = ""; sC17 = ""; sC16 = "";
  sC15 = ""; sC14 = ""; sC13 = ""; sC12 = ""; sC11 = "";
  sC10 = ""; sC9 = ""; sC8 = ""; sC7 = ""; sC6 = "";
  sC5 = ""; sC4 = ""; sC3 = ""; sC2 = ""; sC1 = "";
  sCom = "";
}


void mydelay(int detik) {
  for (int pin = 1; pin <= detik; pin++) {
    msecdelay(1000);
    Serial.print(String(pin) + ".");
    if ((pin % 20) == 0) {
      Serial.println(" ");
    }
  }
  Serial.println(" ");

}

void msecdelay(unsigned long mDetik) {
  // baca counter digital hingga transmisi serial berikutnya
  lastime = millis();
  uBaca = 0;
  while (millis()  < (lastime + mDetik)) {
    uBaca++;
    //reset jika milis kembali 0
    if (millis() < lastime) {
      lastime = millis();
    }
    // read digital value
    for (int pin = 5; pin <= 9; pin++) {
      pinMode(pin, INPUT);
      boolean DigiState = digitalRead(pin);
      // count when state change high to low
      if ((DLast[pin - 2] == HIGH) and (DigiState == LOW))
      {
        DCount[pin - 2] = DCount[pin - 2] + 1;
      }
      DLast[pin - 2] = DigiState;
    }
  }
  // Serial.println("uBaca " + String(uBaca));
}

void Beep(int bSet) {
  pinMode(4, OUTPUT);
  for (int ulang = 1; ulang <= bSet; ulang++) {
    digitalWrite(4, LOW);
    msecdelay(200);
    digitalWrite(4, HIGH);    
    msecdelay(100);
  }
}

void SetSensor(boolean bStatus) {
  pinMode(3, OUTPUT);
  digitalWrite(3, !bStatus);
  //digitalWrite(3, bStatus);
}

void SetModem(boolean bStatus) {
  pinMode(2, OUTPUT);
  digitalWrite(2, !bStatus);
  //digitalWrite(2, bStatus);
}

void SetModemON() {
    StartDev(HIGH); // activate modem
    Serial.println("PowerUp modem in 60s");
    mydelay(60); //wait for modem to be ready
    Serial.println("Init Eth");
    // You can use Ethernet.init(pin) to configure the CS pin
    Ethernet.init(10);  // Most Arduino shields
    // start the Ethernet connection:
    // Ethernet.begin(mac, ip);
    Ethernet.begin(mac);
    Serial.println("connect router in 10s");
    mydelay(10);
    Ethernet.maintain();
    Serial.print(Ethernet.localIP());
    Serial.println(" connect server in 10s");
    // give the Ethernet shield a second to initialize:
    mydelay(10);
}

void StartDev(boolean bDev) {
  //HIGH = modem, LOW = sensor
  if (bDev == HIGH) {
    SetModem(HIGH);
  } else {
    SetSensor(HIGH);
  }
  // when battery low, wait until battery rise
  Serial.print("Batt " + String(analogRead(5)) + " ");
  Serial.println(String(((analogRead(5) * 12.0 / Bat12))));
  while (analogRead(5) < (8.0 * Bat12 / 12.0)) {
    SetModem(LOW);
    SetSensor(LOW);
    Serial.println("Bat Lo, idle 30m");
    Beep(5);
    mydelay(30 * 60);
    if (bDev == HIGH) {
      SetModem(HIGH);
    } else {
      SetSensor(HIGH);
    }
    mydelay(1);
  }
}

void sComRead() {
  StartDev(LOW); //activate sensor
  mydelay(5);
  sCom = "";
  // read the analog in value: A0 to A4 port
  for (int pin = 0; pin <= 2; pin++) {
    // cleaning last reading
    for (int ulang = 0; ulang <= 10; ulang++) {
      AnRead = analogRead(pin);
      delay(2);
    }
    AnRead = 0;
    for (int ulang = 1; ulang <= 5; ulang++) {
      AnRead = analogRead(pin) + AnRead;
      delay(1);
    }
    AnRead = AnRead / 5;
    sCom = sCom + "A" + String(pin) + "-" + String(AnRead) + ";";
  }
  // digital value
  sCom = sCom + "D-";
  // in D5-D9
  for (int pin = 5; pin <= 7; pin++) {
    sCom = sCom + String(digitalRead(pin));
  }
  sCom = sCom + ";" ;
  // digital counter
  for (int pin = 5; pin <= 7; pin++) {
    // counter enabled disabled
    sCom = sCom + "C" + String(pin) + "-" + String(DCount[pin - 2]) + ";";
    //sCom = sCom + "C" + String(pin) + "-0;";
  }
  sCom = sCom + "BT-" + String(((analogRead(5) * 12.0 / Bat12) * 10), 0) + ";";
  sCom = sCom + "TM-" + String(millis() / 60000) + ";";
  Serial.println(sCom);
  SetSensor(LOW); //deactivate sensor
  SavesCom();
  sComLong = sC30.length() + sC29.length() + sC28.length() + sC27.length() + sC26.length() + sC25.length() + sC24.length() + sC23.length() + sC22.length() + sC21.length() + sC20.length() + sC19.length() + sC18.length() + sC17.length() + sC16.length() + sC15.length() + sC14.length() + sC13.length() + sC12.length() + sC11.length() + sC10.length() + sC9.length() + sC8.length() + sC7.length() + sC6.length() + sC5.length() + sC4.length() + sC3.length() + sC2.length() + sCom.length() ;
  Serial.println(sComLong);
  if (sComLong >= 1350) {
    sC20 = sC30; sC19 = sC28; sC18 = sC26; sC17 = sC24; sC16 = sC22;
    sC15 = sC20; sC14 = sC18; sC13 = sC16; sC12 = sC14; sC11 = sC12;
    
    sC30 = ""; sC29 = ""; sC28 = ""; sC27 = ""; sC26 = "";
    sC25 = ""; sC24 = ""; sC23 = ""; sC22 = ""; sC21 = "";
  }
}
